#include <virtuabotixRTC.h>

virtuabotixRTC myRTC(10, 11, 12); //hvilke pins rtc'en er på

const int latchTing = 9; //latch tingelingen til shift registeret
const int dataUd = 7; //data til shift registeret 
const int clockUd  = 8; //clock signal til shift registeret

const int transistor1 = 2;
const int transistor2 = 3;
const int transistor3 = 4;
const int transistor4 = 5;

const int deathpin = A4;

unsigned short birthdayDay = 29;
unsigned short birthdayMonth = 4;
unsigned short birthdayYear = 2007;
//brugerens fødseldag

unsigned short NuvaerendeDag;
unsigned short NuvaerendeMaanede;
unsigned short NuvaerendeAar;
//dagens dato fra rtc'en

const float konstant_vaerdi_1 = 30.437; //gennemsnitlige månedslængde
const float konstant_vaerdi_2 = 365; //dage på et år
const float konstant_vaerdi_3 = 1; //... et 1 tal
const float konstant_vaerdi_4 = 27776.5; //gennemsnitlige levettid for mænd 76,1 år
const float konstant_vaerdi_5 = 2083; //jeg tror at det er dødsdato, er ikke sikker det er lidt tid siden jeg skrev dette
const float konstant_vaerdi_6 = 6; //jeg tror at det er dødsdato, er ikke sikker det er lidt tid siden jeg skrev dette
const float konstant_vaerdi_7 = 2; //jeg tror at det er dødsdato, er ikke sikker det er lidt tid siden jeg skrev dette
//tal brugt i programmet, de står her fordi det ikke virkede hvis man puttede dem direkte i

unsigned int thingyForDisplay;
float thingyForcalculations;

//byte tallene[10] = {B11111100, B00100100, B10111010, B10101110, B01100110, B11001110, B11011110, B10100100, B11111110, B11101110}; //tallene, der bestemmer hvilke segmenter, der skal lyse på displayet
byte talleneHex[10] = {0xFC, 0x24, 0xBA, 0xAE, 0x66, 0xCE, 0xDE, 0xA4, 0xFE, 0xEE}; //tallene i hexidecimal, hvis nu de skal bruge

int numrene[4];
//tallene der bliver vist på displayet

unsigned short delay_periode = 3;//pause mellem tallene, bliver tallet større kan man se displayet blinke, og hvis det er mindre bliver lystyrken svagere, hvilket ikke burde ske pga. pmv  btw. den freaker lidt ud hvis den er sat til under 5
//unsigned short delay_periode = 200; //for at demonstrere at kun et af tallene lyser af gangen

const unsigned long intervalTid = 7200000; //interval mellem opdateringer af urets numre, sker hver anden time

unsigned long forigeTid; //tid der skal bruges til interval tingen
unsigned long koereTid; //tid programmet har kørt i alt

int nultid = false;
const unsigned long doedstid = konstant_vaerdi_5 * konstant_vaerdi_2 + konstant_vaerdi_6 * konstant_vaerdi_1 + konstant_vaerdi_7;
const unsigned long nuvaerendetid;



void setup(){
Serial.begin(9600);

  pinMode(dataUd, OUTPUT); //data til shift registeret
  pinMode(clockUd, OUTPUT); //clock signal til shift registeret
  pinMode(latchTing, OUTPUT); //latch tingelingen til shift registeret

  pinMode(transistor1, OUTPUT);
  pinMode(transistor2, OUTPUT);
  pinMode(transistor3, OUTPUT);
  pinMode(transistor4, OUTPUT);
  //transistorerne

  pinMode(deathpin, INPUT);


  myRTC.updateTime(); //opdater rtc tiderne

  NuvaerendeDag = (myRTC.dayofmonth);
  NuvaerendeMaanede = (myRTC.month);
  NuvaerendeAar = (myRTC.year);


  if (myRTC.year * konstant_vaerdi_2 + myRTC.month * konstant_vaerdi_1 + myRTC.dayofmonth >= doedstid || analogRead(deathpin) >= 512){
   nultid = true; 
   numrene[0] = 0;
   numrene[1] = 0;
   numrene[2] = 0;
   numrene[3] = 0;
   }


  else {
   thingyForcalculations = ((NuvaerendeDag + ((NuvaerendeMaanede - konstant_vaerdi_3) * konstant_vaerdi_1) + (NuvaerendeAar * konstant_vaerdi_2)) - (birthdayDay + ((birthdayMonth - konstant_vaerdi_3) * konstant_vaerdi_1) + (birthdayYear * konstant_vaerdi_2))) / konstant_vaerdi_4;
   //ligningen der meget gerne skulle retunere et procenttal mindre end 100%
   //hvis programmet sender et procenttal tilbage som er over 100% er rtc'en nok blevet nulstillet tilbage til år 2000

   thingyForcalculations = thingyForcalculations * 100;
   thingyForcalculations = 100 - thingyForcalculations;
   thingyForDisplay = thingyForcalculations * 100;

   numrene[0] = (thingyForDisplay / 1000) %10;
   numrene[1] = (thingyForDisplay / 100) %10;
   numrene[2] = (thingyForDisplay / 10) %10;
   numrene[3] = (thingyForDisplay / 1) %10;
   Serial.println(doedstid);
   nuvaerendetid;
   Serial.println(myRTC.year * konstant_vaerdi_2 + myRTC.month * konstant_vaerdi_1 + myRTC.dayofmonth);
  }
}




void loop(){
  
  if (koereTid - forigeTid >= intervalTid && nultid == false){ //procenttallet opdateres hver anden time, medmindre dødstid er aktiv
    if (myRTC.year * konstant_vaerdi_2 + myRTC.month * konstant_vaerdi_1 + myRTC.dayofmonth >= doedstid){
      nultid = true;
      numrene[0] = 0;
      numrene[1] = 0;
      numrene[2] = 0;
      numrene[3] = 0;
      forigeTid = koereTid;
      /*denne del gør sådan, at når uret når datoen, hvor det vil hvise 00.00, 
      så gør den en variabel true, som fortæller en anden del,
      at den andel del skal holde op med at gå igennem ligngingen.
      og denne del sætter også tallene permanent til 00.00
      */
    }


    else{
     //her er så delen, som normalt søger for at opdatere tiden.
     myRTC.updateTime(); //opdater rtc tiderne
     NuvaerendeDag = (myRTC.dayofmonth);
     NuvaerendeMaanede = (myRTC.month);
     NuvaerendeAar = (myRTC.year);
  
     thingyForcalculations = ((NuvaerendeDag + ((NuvaerendeMaanede - konstant_vaerdi_3) * konstant_vaerdi_1) + (NuvaerendeAar * konstant_vaerdi_2)) - (birthdayDay + ((birthdayMonth - konstant_vaerdi_3) * konstant_vaerdi_1) + (birthdayYear * konstant_vaerdi_2))) / konstant_vaerdi_4;
     //ligningen der meget gerne skulle retunere et procenttal mindre end 100%
     //hvis programmet sender et procenttal tilbage som er over 100% er rtc'en nok blevet nulstillet tilbage til år 2000

     thingyForcalculations = thingyForcalculations * 100;
     thingyForcalculations = 100 - thingyForcalculations;
     thingyForDisplay = thingyForcalculations * 100;
     //mere udregning

     numrene[0] = (thingyForDisplay / 1000) %10;
     numrene[1] = (thingyForDisplay / 100) %10;
     numrene[2] = (thingyForDisplay / 10) %10;
     numrene[3] = (thingyForDisplay / 1) %10;
     //deler det endelige tal op i fire, så der er et til hvert digit på displayet

     forigeTid = koereTid; //nulstiller køretiden, så der går endnu tre timer før procenttallet opdateres
    }
  }

  else{
   shiftOut(dataUd, clockUd, LSBFIRST, talleneHex[numrene[0]]);
   digitalWrite(transistor4, LOW);
   digitalWrite(latchTing, HIGH);
   digitalWrite(latchTing, LOW);
   digitalWrite(transistor1, HIGH);
   delay(delay_periode);

   shiftOut(dataUd, clockUd, LSBFIRST, talleneHex[numrene[1]] + 1);
   digitalWrite(transistor1, LOW);
   digitalWrite(latchTing, HIGH);
   digitalWrite(latchTing, LOW);
   digitalWrite(transistor2, HIGH);
   delay(delay_periode);

   shiftOut(dataUd, clockUd, LSBFIRST, talleneHex[numrene[2]]);
   digitalWrite(transistor2, LOW);
   digitalWrite(latchTing, HIGH);
   digitalWrite(latchTing, LOW);
   digitalWrite(transistor3, HIGH);
   delay(delay_periode);

   shiftOut(dataUd, clockUd, LSBFIRST, talleneHex[numrene[3]]);
   digitalWrite(transistor3, LOW);
   digitalWrite(latchTing, HIGH);
   digitalWrite(latchTing, LOW);
   digitalWrite(transistor4, HIGH);
   delay(delay_periode);
   koereTid = millis();
   //denne del søger bare for at sende tallene ud til displayet
     
 } 
}
